Imports System.Data
Imports System.Data.SqlClient
Imports System.IO

Partial Class _Default
    Inherits System.Web.UI.Page

#Region " SQL Scripts"

    'GO
    'create table files
    '(
    ' id int identity(1,1),
    ' [file] varbinary(max),
    ' fname nvarchar(250)
    ')
    'GO

#End Region

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim con As New SqlConnection("Server=localhost;uid=myUsername;pwd=myPasswrd;database=works")
        Dim da As New SqlDataAdapter("Select * From files", con)

        Dim MyCB As SqlCommandBuilder = New SqlCommandBuilder(da)
        Dim ds As New DataSet()

        da.MissingSchemaAction = MissingSchemaAction.AddWithKey

        Dim fs As New FileStream("C:\print-button.JPG", FileMode.OpenOrCreate, FileAccess.Read)

        Dim MyData(fs.Length) As Byte
        fs.Read(MyData, 0, fs.Length)
        fs.Close()
        con.Open()

        da.Fill(ds, "MyImages")

        Dim myRow As DataRow
        myRow = ds.Tables("MyImages").NewRow()

        myRow("file") = MyData
        myRow("fname") = fs.Name
        ds.Tables("MyImages").Rows.Add(myRow)
        da.Update(ds, "MyImages")

        fs = Nothing
        MyCB = Nothing
        ds = Nothing
        da = Nothing

        con.Close()
        con = Nothing
        Response.Write("Image saved to database")

    End Sub

    Protected Sub Button3_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button3.Click

        Dim con As New SqlConnection("Server=localhost;uid=myUsername;pwd=myPasswrd;database=works")
        Dim da As New SqlDataAdapter("select top 1 * from files order by id desc", con)
        Dim MyCB As SqlCommandBuilder = New SqlCommandBuilder(da)
        Dim ds As New DataSet()

        con.Open()
        da.Fill(ds, "files")
        Dim myRow As DataRow
        myRow = ds.Tables("files").Rows(0)

        Dim MyData() As Byte
        MyData = myRow("file")

        Response.Buffer = True
        Response.ContentType = "Image/JPEG"
        Response.BinaryWrite(MyData)

        MyCB = Nothing
        ds = Nothing
        da = Nothing

        con.Close()
        con = Nothing

    End Sub

    Protected Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click

        Dim con As New SqlConnection("Server=localhost;uid=myUsername;pwd=myPasswrd;database=works")
        Dim da As New SqlDataAdapter("select * from files", con)
        Dim MyCB As SqlCommandBuilder = New SqlCommandBuilder(da)
        Dim ds As New DataSet()

        con.Open()
        da.Fill(ds, "files")
        Dim myRow As DataRow
        myRow = ds.Tables("files").Rows(0)

        Dim MyData() As Byte
        MyData = myRow("file")

        Response.Buffer = True
        Response.ContentType = "Image/JPEG"
        Response.BinaryWrite(MyData)

        MyCB = Nothing
        ds = Nothing
        da = Nothing

        con.Close()
        con = Nothing

    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load



    End Sub

    Protected Sub Button4_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button4.Click

        'If IsPostBack Then

        Dim path As String = Server.MapPath("~/UploadedImages/")

        Dim fileOK As Boolean = False

        If FileUpload1.HasFile Then

            Dim fileExtension As String
            fileExtension = System.IO.Path.GetExtension(FileUpload1.FileName).ToLower()

            Dim allowedExtensions As String() = {".jpg", ".jpeg", ".png", ".gif"}

            For i As Integer = 0 To allowedExtensions.Length - 1
                If fileExtension = allowedExtensions(i) Then
                    fileOK = True
                End If
            Next

            If fileOK Then
                Try
                    '****************
                    'Load to database or file upload to upload folder
                    'Both will not work at the same time
                    '****************
                    LoadToDB()
                    FileUpload1.PostedFile.SaveAs(path & _
                         FileUpload1.FileName)
                    Label1.Text = "File uploaded!"
                Catch ex As Exception
                    Label1.Text = ex.Message & vbCrLf & ex.InnerException.ToString
                End Try
            Else
                Label1.Text = "Cannot accept files of this type."
            End If

        End If

        'End If

    End Sub

    Private Sub LoadToDB()

        Dim con As New SqlConnection("Server=localhost;uid=myUsername;pwd=myPasswrd;database=works")
        Dim da As New SqlDataAdapter("Select * From files", con)

        Dim MyCB As SqlCommandBuilder = New SqlCommandBuilder(da)
        Dim ds As New DataSet()

        da.MissingSchemaAction = MissingSchemaAction.AddWithKey

        'Dim fs As New FileStream("C:\Activate Windows Now.JPG", FileMode.OpenOrCreate, FileAccess.Read)
        Dim fs As System.IO.Stream = FileUpload1.PostedFile.InputStream()


        Dim MyData(fs.Length) As Byte
        fs.Read(MyData, 0, fs.Length)
        fs.Close()
        con.Open()

        da.Fill(ds, "MyImages")

        Dim myRow As DataRow
        myRow = ds.Tables("MyImages").NewRow()

        myRow("file") = MyData
        myRow("fname") = FileUpload1.PostedFile.FileName
        ds.Tables("MyImages").Rows.Add(myRow)
        da.Update(ds, "MyImages")

        fs = Nothing
        MyCB = Nothing
        ds = Nothing
        da = Nothing

        con.Close()
        con = Nothing
        Response.Write("Image saved to database")

    End Sub

End Class